 /* **** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is refspoof for Mozilla.
 *
 * The Initial Developer of the Original Code is Boyd Ebsworthy.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Ernesto Bricca 2004/08/02 added spoof protocol / bookmark handling / ui change
 * 
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


function rstb() {

  // toolbar specific prefs are in utils.js .. prefsystem.js handles xul readout/init 
};

rstb.prototype = {

	/* dtor  not used why anyway
	onDestroy : function () {  },
        */


	/******************************************************************************************
 	* spoof()
 	* called by spoof button in overlay
 	*/
	spoof : function () {
		// gui change
		var spoofButton = document.getElementById(comVar.SPOOF_BUTTON_ID.gui);

		spoofButton.checked=true;

		var URI   = document.getElementById(comVar.URLBAR_ID.gui).value;
	
		this.openURI(URI, this.getReferer());

		// gui change
		// 0.1s button flicker .. function looses local vars
		setTimeout("document.getElementById(comVar.SPOOF_BUTTON_ID.gui).checked=false;",100); 

	},


	/*****************************************************************************************
	 * check the users settings for "open in tab" then calls reallyOpenURI with the
	 * appropriate parameters. splitted to be able to call from the contextmenu
	 */
	openURI : function (URI, refURI) {
		this.reallyOpenURI(URI, refURI, prefs.talktoPref(comVar.OPENTAB_ID));
	},

	toggleOpenTab : function (){
		// pref change
		var enabled = prefs.talktoPref(comVar.OPENTAB_ID, !(prefs.talktoPref(comVar.OPENTAB_ID)));

		// gui change
		var eOpenTab = document.getElementById(comVar.OPENTAB_ID.gui);
		if (enabled) {
			eOpenTab.setAttribute("checked", true);
		} else if (!enabled) {
		eOpenTab.setAttribute("checked", false);
		} else {dumpme("unknown state")} 
	},


	/*****************************************************************************************
	* reallyOpenURI() - for lack of a better name.
	* URI		= destination url
	* refURI	= referer url
	* toTab	= true : open destination in a new tab. false : use current browser.
	*/

	reallyOpenURI : function (URI , refURI, toTab){

		if(!URI){
			dumpBrowserMsg("--> no url was given in the urlbar");
			return;
		}

		if(!refURI) {
			dumpBrowserMsg("--> no referrer was given in the refbar");
			return;

		}

		/* clean up the ! */
		URI 		= this.cleanURI(URI);
		refURI  	= this.cleanURI(refURI);
		
		//create spoof uri
		
		spoofURI = this.uriConvert(URI, "spoof")+";"+ this.uriConvert(refURI, "ref");

		var browser = getBrowser();

		if(toTab) {
			var tab = browser.addTab(spoofURI);

			if (!prefs.talktoPref(comVar.BROWSER_LOAD_TABS_IN_BG_ID))
			browser.selectedTab = tab;
		} else {
			browser.loadURI(spoofURI);
		}
	},



	/*****************************************************************************************
 	* referer handling
 	**/

	getReferer : function () {
		var refisurl = prefs.talktoPref(comVar.URLISREF_ID);
		if(refisurl){
			return document.getElementById(comVar.URLBAR_ID.gui).value;
		} else {
			refbarValue=document.getElementById(comVar.REFBAR_ID.gui).value;
			this.addRefbarMenuItem(refbarValue);
			return refbarValue;
		}
	},

	toggleUrlref : function(enable){


		// pref change
		if (enable==null){
		 var enabled = prefs.talktoPref(comVar.URLISREF_ID, !(prefs.talktoPref(comVar.URLISREF_ID)));
		 enable = !enabled
		}
		
		// gui change
		var eRefurl = document.getElementById(comVar.URLISREF_ID.gui);
		var eRefbar = document.getElementById(comVar.REFBAR_ID.gui);
		
		if (!enable) {
			eRefbar.value = "";  // clean refbar
			eRefurl.checked = true;
			eRefbar.setAttribute("disabled", "true");
			// notice how it works
			if (prefs.talktoPref(comVar.URLREFNAG_ID)) {
				dumpBrowserMsg("click the 'spoof button' - to spoof (load) the actual page with urlbar url as referrer");
			}
		} else if (enable) {
			eRefurl.checked = false;
			eRefbar.removeAttribute("disabled");
		} else {dumpme("unknown state");}
	},
	
	

	addRefbarMenuItem : function(term){

		if(term=="") {
			dumpBrowserMsg("--> no referrer was given in the refbar -- it would be just behave like a normal bookmark :/");
			return;
		}
		var myRefbarMenuList = document.getElementById(comVar.REFBAR_ID.gui);
		var myRefbarPopup = myRefbarMenuList.firstChild;

		var intMaxHistory = prefs.talktoPref(comVar.REFBAR_ID);
		var alreadyInHistory = false;
		var intNrHistoryItems = myRefbarPopup.childNodes.length; 

		for (var i = 0; i < intNrHistoryItems; i++) {
			if (term == myRefbarPopup.childNodes[i].getAttribute("label")) {
				alreadyInHistory = true;
			}
		}

		if(!alreadyInHistory) {
			// Add search term to history list 
			var newMenuItem = document.createElement("menuitem");
			newMenuItem.setAttribute("label", term);
			myRefbarPopup.insertBefore(newMenuItem, myRefbarPopup.childNodes[0]);
  	
			// Check the length of dropdown list an cut if ness
			if (myRefbarMenuList.firstChild.childNodes.length >= intMaxHistory){
				myRefbarMenuList.removeItemAt(intMaxHistory);
			}
		}
 
	},


	cleanHist : function (){
		var myRefbarMenuList = document.getElementById(comVar.REFBAR_ID.gui);

		var i = 0;
		var len = 0;

		len = myRefbarMenuList.firstChild.childNodes.length;
		for(i = len - 1; i > -1; i--) {
			myRefbarMenuList.removeItemAt(i); 
		}
	},

	dumpRef : function (){  // to the refbar

		if (prefs.talktoPref(comVar.URLISREF_ID)) {
			this.toggleUrlref();
		}
		myRef=getBrowser().contentDocument.referrer;
		document.getElementById(comVar.REFBAR_ID.gui).value=myRef;
	},


	/*****************************************************************************************
	 * sidebar
	 **/

        // gets called in the xul 

	/*****************************************************************************************
	 * bookmark functions
	 **/

	bookmark : function(){
		// gui change
		var bookmButton = document.getElementById(comVar.BM_BUTTON_ID.gui);
		bookmButton.checked=true;

		// storeMethod:
		// 0==read out the refbar and the urlbar
		// 1==use the properties of the topfront page
		// todo -- behaviour shall be able to be reversed via alt
		var myUri="";var myRef="";

// keypressed shift modulo % -- storeMethod = (storeMethod + 1) % 2 
//-- counterpart in the xul from utils.js
 		var storeMethod = prefs.talktoPref(comVar.STORE_METHOD_ID);
 		var shiftPressed = prefs.talktoPref(comVar.SHIFT_PRESSED_ID);
 		if (shiftPressed == 1){storeMethod = (storeMethod + 1) % 2}


		switch (storeMethod){
		case 0:
			myUri=document.getElementById(comVar.URLBAR_ID.gui).value;
			myRef=this.getReferer();
			break;
		case 1:
			myUri=getBrowser().contentDocument.location;
			myRef=getBrowser().contentDocument.referrer;
		}

		if(myUri=="" || myRef=="") {  // pbly later store as simple url if myRef=="" but error msg is better
			dumpd("no url or ref was given");
		} else {

		myUri  = this.cleanURI(myUri);
		myRef  = this.cleanURI(myRef);
		
		myUri = this.uriConvert(myUri, "http");
		myRef = this.uriConvert(myRef, "http");
		
		this.storeSpoof(myUri, myRef);
		}

		// gui change
		// .1 s button flicker .. function looses local vars
		setTimeout("document.getElementById(comVar.BM_BUTTON_ID.gui).checked=false;",100); 
		
	},

	storeSpoof : function(myUri, myRef){
		// convert to spoofuri

		myUri = myUri.replace("http://", "spoof://");
		title = myUri;
		myRef = myRef.replace("http://", "ref://");
		spoofUri = myUri +";"+ myRef;


// analog from above	
		// storeLocation:
		// 0==show save dialog
		// 1==use the selected folder as direct save
		// todo -- behaviour shall be able to be reversed via alt
	
//-- counterpart in the xul from utils.js
 		var storeLocation = prefs.talktoPref(comVar.STORE_LOCATION_ID);
 		var altPressed = prefs.talktoPref(comVar.ALT_PRESSED_ID);
 		if (altPressed == 1){storeLocation = (storeLocation + 1) % 2}

		//createBookmark		
		switch (storeLocation){
		case 0:
			window.openDialog(
				'chrome://browser/content/bookmarks/addBookmark2.xul',
				'',
				'modal,centerscreen,chrome,dialog,resizable,dependent',
				title,
				spoofUri,
				null,
				null,
				'',
				'');
			break;
		case 1:
		
			refspoofFolderID = prefs.talktoPref(comVar.SPOOFMARK_FOLDER_ID);
			charSet="UTF-8";

			var rSource = BookmarksUtils.createBookmark(title, spoofUri, charSet, title);  
			var selection = BookmarksUtils.getSelectionFromResource(rSource);
			var tFolder = RDF.GetResource(refspoofFolderID);
			var target = BookmarksUtils.getTargetFromFolder(tFolder);
      
			BookmarksUtils.insertAndCheckSelection("newbookmark", selection, target);
			
			// be sure -- on alt click ?? doesnt jump back in the main function
		    setTimeout("document.getElementById(comVar.BM_BUTTON_ID.gui).checked=false;",2000); 

		}
	
			
	},


	/*****************************************************************************************
	 * aid
	 **/

	/* removes '!' from URLs */
	
	cleanURI : function (URI) {
		//strip the bang
		URI = URI.toString();
		URI = URI.replace(/!/g, "");
		return URI;
	},


	uriConvert : function (URI, scheme) {
	
		if (URI.substr(0,6) == "spoof:") {
		// if its a spoof uri cut away the ref and reformat
			var partURI = URI.split(";");
			URI = partURI[0];

			URI = "http:" + URI.substr(6);
			dumpme(URI);
		}
		
		// could be refined a bit to represent the other standard notations http:, http:/, http://
		// even the component could be refined
		if (URI.substr(0,6) != "http:/") {
			URI = "http://" + URI;
		}
		return scheme + URI.substr(4);
	},

	/*****************************************************************************************
	 * prefsystem
	 **/

	prefWindow: function () {

		window.openDialog(
			'chrome://refspoof/content/options.xul',
			'',
			'centerscreen,chrome,dialog,resizable,dependent'
		);

	},

	convWindow: function () {

		window.openDialog(
			'chrome://refspoof/content/convert.xul',
			'',
			'centerscreen,chrome,dialog,resizable,dependent'
		);
	},
	

	/*****************************************************************************************
	 * context menu handler function
	 * gContextMenu info in : contentAreaContextOverlay.xul and nsContextMenu.js
	 * see contentAreaUtils.js for usefull stuff.
	 **/


	contextMenuListener : function() {
		if(gContextMenu) {
			gContextMenu.showItem( "context-spoof", gContextMenu.isTextSelected || gContextMenu.onLink);
			gContextMenu.showItem( "context-spoof-sep", gContextMenu.isTextSelected || gContextMenu.onLink);
		}
	},

	// get data under the cursor, selected text then link.
	getContextData : function () {
		var data = '';
		if(gContextMenu.isTextSelected) {
			data = gContextMenu.searchSelected();
		} else if(gContextMenu.onLink) {
			data = gContextMenu.linkURL();
		} else { alert('nothing useful here :)'); }

		return data;
	},

	// open as ref = url the context menu target //openContextDataAsURI
	openContextDataAsURI : function() {
		var URI = this.getContextData();
		if(URI != '') {
			// copied from toggleUrlref hack!
			var enabled = prefs.talktoPref(comVar.URLISREF_ID, !(prefs.talktoPref(comVar.URLISREF_ID)));
			if (enabled) {this.toggleUrlref();}
			this.openURI(URI, URI);
		}
	},

	// set the urlbar to context menu target
	setContextDataToURLBar : function () {
		var URI = this.getContextData();
		if(URI != '') {
			document.getElementById(comVar.URLBAR_ID.gui).value = URI;
		}
	},

	// set the referer bar to context menu target
	setContextDataToRefererBar : function () {
		var URI = this.getContextData();
		if(URI != '') {
			// copied from toggleUrlref hack!
			var enabled = prefs.talktoPref(comVar.URLISREF_ID, !(prefs.talktoPref(comVar.URLISREF_ID)));
			if (!enabled) {this.toggleUrlref();}
			document.getElementById(comVar.REFBAR_ID.gui).value = URI;
		}
	}


};



	/*****************************************************************************************
	 * dragNdrop
	 **/


function myretrieveURLFromData (aData, flavour) {

		switch (flavour) {
			//XXX : for some reason when plain text is dragged from
			//the content area, the flavour is set a text/x-moz-url
			//i don't know how to differentiate an url from a text drag.
			case "text/unicode":
			case "text/x-moz-url":
				var data = aData.toString();
				//remove leading useless char
				data = data.replace(/^(\n|\r|\t|\s)+/g, "");
				//remove trailing useless char
				data = data.replace(/(\n|\r|\t|\s)+$/g, "");
				//extract url from possible valid x-moz-uri
				var separator = data.indexOf("\n");
   				if (separator != -1)
					data = data.substr(0, separator);

				return data;

			case "application/x-moz-file":
				var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
				return ioService.getURLSpecFromFile(aData);
  		}
  		return null;
	}
	

	
/***** DnD test *****/
var btDragObserver = {

	onDrop: function (aEvent, aXferData, aDragSession) {
		var url = myretrieveURLFromData(aXferData.data, aXferData.flavour.contentType);
		if(url) {
			rstb.toggleUrlref(true);
			rstb.openURI(url, url);
		}
	},

	onDragOver: function (aEvent, aFlavour, aDragSession) {
		// shows the curser uparrow but doesnt allow other interface change like statusbar switch :/
		aDragSession.dragAction = Components.interfaces.nsIDragService.DRAGDROP_ACTION_LINK;

	},
	

	getSupportedFlavours: function () {
		var flavourSet = new FlavourSet();

		flavourSet.appendFlavour("application/x-moz-file", "nsIFile");
		flavourSet.appendFlavour("text/x-moz-url");
		flavourSet.appendFlavour("text/unicode");

		return flavourSet;
	}
	
}


